#game_include("actor_plus.jl")

function FishSprite(name = "", item = dict{})
    #println(item)
    #'''鱼精灵'''
    actor=Actor(item["file"][1])
    actor.name = name                         #鱼的名字
    actor.life = item["life"]                 #生命值
    actor.score = item["score"]               #得分
    actor.is_turn = item["turn"]              #是否允许游动时转向
    actor.is_capture = false                  #是否被捕获
    actor.alpha = 255#false                   #是否可见（alpha值0-255）
    actor.death_time = 0                      #鱼挣扎死亡的时间
    actor.change_time = time()               #鱼上次改变路线的时间
    actor.rotation = 0                        #旋转角度
    actor.speed = item["speed"]              #游动速度
    actor.acc = 0                            #加速度
    actor.images=item["file"]                 #用于生成鱼游动的动画的图片文件集
    actor.frame=1                             #记录鱼动画当前显示的图片在集合中的索引
    
    #'''鱼的起点'''    
    if rand(1:10) > 5
        actor.x = 0 - rand(256:512)
    else
        actor.x = rand(1024:1536)
    end
    actor.y = rand(0:668)
    point(actor,512, 284)
    return actor
end

function swim(fish, dt)
    #'''鱼儿游动'''
    #println(time() - fish.change_time)
    if time() - fish.change_time > 3
        #println(time() - fish.change_time)
        fish.change_time = time()
        if -512 < fish.x < 1536 && -484 < fish.y < 1052
            if fish.is_turn==1
                fish.rotation = rand(-10:10)
                fish.acc = rand(-10:fish.speed // 2)
            end
        end
    end
    #随机转向、加减速移动
    left(fish,fish.rotation * dt)
    move(fish,(fish.speed + fish.acc) * dt)
    #超出范围时让鱼消失
    if !(-1024 < fish.x < 2048 && -768 < fish.y < 1536)
        #fish.visible = False
        fish.alpha=0
    end
end
function check_dead(fish::Actor, dt)
    #'''鱼儿是否死亡'''
    if fish.alpha==255
        fish.death_time += 1 * dt
        if fish.death_time > 1
            fish.alpha=0
            #self.visible = False
        end
    end
end