game_include("game_res.jl")
game_include("game_sprites.jl")
game_include("actor_plus.jl")
import JSON

# Height of the game window
HEIGHT = 668
# Width of the game window
WIDTH = 1024
# Background color of the game window
BACKGROUND = bg_img
#全局变量
fishes, bullets, nets, coins = [], [], [], []
score, game_time, auto_play = 0, 0, false
dictFishes=JSON.parse(fishes_config)
panel = Actor(panel_img;pos=(130,597))
cannon = Actor(cannon_img, pos=(507,610))
score_label=TextActor("000000","Arial-Black",font_size=24, color=Int[255,255,255,255])
score_label.pos=(165,635)
# The draw function is called by the framework. All we do here is draw the Actor
function draw(g::Game)
    clear()
    draw_actor(fishes)
    draw(panel)
    draw(score_label)
    draw(cannon)
end
function on_mouse_move(g::Game, pos)
    x, y = pos
   point(cannon,x,y)
end

function draw_actor(actors)
    #绘制角色
    for actor in actors
        #println(actor.alpha)
        if actor.alpha==255
            draw(actor)
        end
    end
end
function make_fishes(dt)
    global game_time
    game_time += 1 * dt
    
    for (fish_name, item) in dictFishes
        if item["alive"] == 0
            num = item["max"] // 2
        elseif item["alive"] < item["max"] // 3
            num = item["max"] - item["alive"]
        else
            num = 0
        end
        if fish_name == "蓝鲨" && floor(Int,game_time + 1) % 300 == 0
            num = item["max"] - item["alive"]
        end
        if fish_name == "金鲨" && floor(Int,game_time + 1) % 480 == 0
            num = item["max"] - item["alive"]
        end
        for i in 1 : num #range(num)
            fish = FishSprite(fish_name,item)
            item["alive"] += 1
            push!(fishes,fish)
        end
    end
end

function fishes_control(dt)
    #鱼群
    for fish in fishes
        if fish.life > 0
            swim(fish,dt)
        else
            if not fish.is_capture
                fish.is_capture = true
                #将图片索引指定为在鱼披捕获时显示扭动的动画图像的第一张
                fish.frame=length(fish.images)/2+1
                #换成鱼扭动的造型
                #fish.twist()
                #释放金币
                release_coin(fish.position, fish.score)
            else
                #挣扎1秒后消失
                check_dead(fish,dt)
            end
        end
        if fish.alpha==0
            #减少鱼的存活数
            dictFishes[fish.name]["alive"] -= 1
            #fishes.remove(fish)
            #delete!(fishes,fish)
            filter!(e->e≠fish,fishes)
            #fish.delete()
        end
    end
end
function update(g::Game,dt)
    make_fishes(dt)
    
    fishes_control(dt)
end
function fi_control()
    fish.angle+=10
end
#鱼动画
function fishes_animation()
    for fish in fishes
        _frame = fish.frame
        #item=dictFishes["小黄鱼"]
        #鱼是否被捕获
        if fish.is_capture==false
            if _frame < (length(fish.images)/2+1)
                fish.image = fish.images[_frame]
                _frame += 1
                
            else
                _frame = 1
            end
            fish.frame=_frame
        else
            if _frame < length(fish.images)+1
                fish.image = fish.images[_frame]
                _frame += 1
                
            else
                _frame = length(fish.images)/2+1
            end
            fish.frame=_frame
        end
        
    end
    schedule_once(fishes_animation, 1/16)
   
end
#schedule_interval(fi_control, 3)
fishes_animation()